<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Admin\Services\RoleService;
use App\Http\Controllers\Controller;
use App\Http\Resources\Admin\CreateRoleRequest;
use App\Http\Resources\Admin\UpdateRoleRequest;
use Illuminate\Http\Request;

class RoleController extends Controller
{
    public function __construct()
    {
        $this->middleware(['auth:sanctum','isAdmin']);
        $this->middleware('can:read-roles')->only(['allRole','showRole']);
        $this->middleware('can:create-roles')->only(['createRole']);
        $this->middleware('can:edit-roles')->only(['updateRole']);
        $this->middleware('can:delete-roles')->only('deleteRole');
    }

    public function allRole(Request $request,RoleService $role)
    {
        $roles=$role->index();
        if (count($roles)){
            return response()->json(['success'=>true,'data'=>['roles'=>$roles]]);
        }
        else{
            return response()->json(['success'=>true,'data'=>['roles'=>[]]]);

        }
    }
    public function createRole(CreateRoleRequest $request,RoleService $role)
    {
        $create_role=$role->create($request);
        if ($create_role == true){
            return response()->json(['success'=>true]);
        }
        else{
            return response()->json(['success'=>false,'message'=>'Operation failed. Please try again']);

        }
    }
    public function updateRole(UpdateRoleRequest $request,$roleId,RoleService $role)
    {
//        return 1;
        $updated_role=$role->update($request,$roleId);
//        return $updated_role;
        if ($updated_role['success'] == true){
            return response()->json(['success'=>true]);
        }
        else{
            return response()->json(['success'=>false,'message'=>$updated_role['message']]);

        }
    }
    public function showRole($roleId,RoleService $role)
    {
        $show_role=$role->show($roleId);
        if ($show_role){
            return response()->json(['success'=>true,'data'=>['role'=>$show_role]]);
        }
        else{
            return response()->json(['success'=>false,'message'=>'The role could not be found']);

        }
    }
    public function deleteRole(Request $request,$roleId,RoleService $role)
    {
        $delete_role=$role->delete($roleId);
        if ($delete_role){
            return response()->json(['success'=>true]);
        }
        else{
            return response()->json(['success'=>false,'message'=>'The role could not be found']);
        }
    }
}
