<?php

namespace App\Http\Controllers\Admin\Services;
use App\Models\Admin\Admin;
use phpDocumentor\Reflection\PseudoTypes\NonEmptyLowercaseString;

class AdminService
{
    //show all admins
    public function all($adminId)
    {
        $admins=Admin::query()->with('role')->where('id','!=',$adminId)->get();
        if (count($admins) > 0 ){
            return $admins;
        }
        else{
            return  false;
        }
    }
    //create new admin
    public function create($request)
    {
        $admin=new Admin();
        $admin->name=$request->name;
        $admin->email=$request->email;
        $admin->password=\Hash::make($request->password);
        $admin->role_id=$request->role_id;
        $admin->save();
        return $admin;
    }
    //update admin
    public function update($request,$adminId)
    {
//        return 1;

        $admin=Admin::query()->where('id',$adminId)->first();
//        return $request['name'];
        if ($admin){
            $admin->name=$request['name'] !== null ? $request['name'] : $admin['name'];
            $admin->role_id=$request['role_id'] !== null ? $request['role_id']: $admin['role_id'];
//            return $admin;

            $check_email=Admin::query()->where('email',$request['email'])
                ->where('id','!=',$adminId)->first();
            if (!$check_email){
                $admin->email=$request['email']  !== null ? $request['email'] : $admin['email'];

            }

            else{
                return ['success'=>false,'message'=>'The email has already been taken.'];

            }
             $admin->save();
            return ['success'=>true,'admin'=>Admin::query()->where('id',$adminId)->first()];
        }
        else{
            return ['success'=>false,'message'=>'The desired admin was not found'];

        }
    }
    //show admin
    public function show($adminId)
    {
        $admin=Admin::query()->where('id',$adminId)->first();
        if ($admin){
            return ['success'=>true,'admin'=>$admin];
        }
        else{
            return ['success'=>false,'message'=>'The desired admin was not found'];

        }
    }
    // delete admin
    public function delete($adminId)
    {
        $admin=Admin::query()->where('id',$adminId)->first();
        if ($admin){
            $admin->delete();
            return ['success'=>true];
        }
        else{
            return ['success'=>false,'message'=>'The desired admin was not found'];

        }
    }
}
