<?php

namespace App\Http\Requests\Client;

use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use Illuminate\Validation\Rule;

class RegisterRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules(Request $request)
    {
//        Log::info($request->all());

        return [
            'email' => ['required','email', 'min:3', 'max:200'],
            'password' => ['required','min:6', 'max:20'],
            'confirmation_code' => ['numeric','digits:5'],
            'referral_code' => ['nullable','numeric','digits_between:5,20'],
            'job_title_id'=>['exists:job_titles,id'],
//            'name'=>[],
//            'familiar_method' => ['regex:/^[a-zA-Z\s]+$/', 'max:50', 'min:2']
            'familiar_method.*' => ['in:instagram_count,friend_count,google_count,facebook_count,other_count','max:50']
        ];
    }
}
