<?php

namespace App\Http\Requests;

use Illuminate\Foundation\Http\FormRequest;

class CommentRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        if ($this->isMethod('get')) {
            return [
                'profile_id' => ['required'],
                'profile_type' => ['required', 'in:user,company,project']
            ];
        }
        return [
            'text' => ['required', 'string', 'min:3', 'max:2000'],
            'rate' => ['nullable', 'numeric', 'between:1,5'],
            'to' => ['nullable', 'string', 'min:3', 'max:200'],
            'profile_id' => ['required', 'numeric'],
            'profile_type' => ['required', 'in:user,company,project'],
            'parent_id' => ['nullable', 'numeric']
        ];
    }
}
