<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Storage;

class Image extends Model
{
    use \Staudenmeir\EloquentEagerLimit\HasEagerLimit;
    use HasFactory;

    protected $table = 'images';

    protected $guarded = [
        'id'
    ];

    public function imageable()
    {
        return $this->morphTo();
    }

    public function client()
    {
        return $this->morphTo();
    }

    public function keywords()
    {
        return $this->belongsToMany(Keyword::class, 'image_keyword');
    }

    public function getNameAttribute($value)
    {
        return $value != null ? Storage::disk('public')->url('/images/' . $value) : $value;
    }
    public function scopeLastActivity($query)
    {
        return $query->limit(4);
    }
    public function style()
    {
        return $this->belongsToMany(Style::class, 'style_images');
    }

}
