<?php

namespace App\Repositories;

use App\Models\Estimate;
use Illuminate\Support\Facades\Auth;
use JasonGuru\LaravelMakeRepository\Repository\BaseRepository;

//use Your Model

/**
 * Class EstimateRepository.
 */
class EstimateRepository extends BaseRepository
{
    /**
     * @return string
     *  Return the model
     */
    public function model()
    {
        return Estimate::class;
    }

    public function store($data, $imageName, $referenceNumber, $client)
    {
        return Estimate::query()->create([
            'customer_name' => $data['customer_name'],
            'customer_email' => $data['customer_email'],
            'start_date' => $data['start_date'],
            'end_date' => $data['end_date'],
            'reference_number' => $referenceNumber,
            'estimateable_type' => get_class($client),
            'estimateable_id' => $client->id,
            'address' => $data['address'],
            'message' => $data['message'],
            'latitude' => $data['latitude'],
            'longitude' => $data['longitude'],
            'pdf_address' => $data['pdf_address'],
            'sub_total' => $data['sub_total'],
            'discount' => $data['discount'],
            'discount_type' => $data['discount_type'],
            'sale_tax' => $data['sale_tax'],
            'image' => $imageName,
            'total' => $data['total'],
            'status' => 'sent'
        ]);
    }


    public function show($id, $client)
    {
//        return get_class($client);
        return Estimate::query()->where('id', $id)
            ->where('estimateable_type', get_class($client))
                ->where('estimateable_id', $client->id)
//            ->with('lists')
//       ->with('lists',function ($q){$q->select('listable_id','listable_type','service','description','rate','quantity','amount');})

            ->first();
    }
    public function showList($client)
    {
        return Estimate::query()
            ->where('estimateable_type', get_class($client))
            ->where('estimateable_id', $client->id)
//            ->with('lists',function ($q){$q->select('listable_id','listable_type','service','description','rate','quantity','amount');})
            ->select('id','customer_name','address','reference_number','total','message','pdf_address','status')
            ->get();
    }

    public function deleteEstimate($id)
    {
        return Estimate::query()->where('id', $id)->delete();
    }


    public function addNote($id,$data)
    {
        return Estimate::query()->where('id', $id)->update([
            'status' => $data['status'],
            'report' => $data['report']
        ]);
    }
}
