<?php

namespace App\Services;

use App\Models\Address;
use App\Models\City;
use App\Models\State;
use App\Repositories\AddressRepository;

class AddressService
{
    private $repository;
    public function __construct()
    {
        $this->repository = new AddressRepository();
    }

    public function store($request, $type, $id)
    {
        return $this->repository->store($request, $type, $id);
        //dd($address);
    }


    public function checkValidAddress($country, $state, $city)
    {
        $findCity = City::where('name', $city)->with('state')->get();
        $stateName = $findCity->toArray()[0]['state']['name'];
        $findCountry = State::where('name', $stateName)->with('country')->get();
        $countryName = $findCountry->toArray()[0]['country']['name'];
        if (strtolower($countryName) == strtolower($country) && strtolower($stateName) == strtolower($state)) {
            return 1;
        }
        return 0;
    }

    public function searchAddressInMap()
    {
        //The URL with parameters / query string.
        $url = 'http://google.com?id=1&name=wayne';

//Once again, we use file_get_contents to GET the URL in question.
        $contents = file_get_contents($url);

//If $contents is not a boolean FALSE value.
        if($contents !== false){
            //Print out the contents.
            echo $contents;
        }
    }

    public function checkExist($clientType, $clientId)
    {
        $entity = $clientType::find($clientId);
        if ($entity == null)
            return null;
        return $entity->address()->first();
    }

    public function update($request,$id)
    {
        return $this->repository->update($request,$id);
    }

    public function delete($addressableType, $addressableId)
    {
        return Address::where('addressable_type', $addressableType)->where('addressable_id', $addressableId)->delete();
    }
}
