<?php

namespace App\Services;

use App\Models\Admin\Structure\SiteInformation;
use App\Models\CountProject;
use Illuminate\Support\Facades\DB;

class CodeService
{
    public function check($modelName, $codeType, $code)
    {
        if (!is_array($modelName))
            return $modelName::where($codeType, $code)->first();

        foreach ($modelName as $model) {
            //dd($modelName);
            $data = $model::where($codeType, $code)->first();
            if (!!$data)
                return $data;
        }
        return null;
    }

    public function addInvitation($clientType, $clientId)
    {
        //return $modelName::where('id', $id)->increment('total_invitation');
        $client = DB::table('count_project')->where(['client_type' => $clientType, 'client_id' => $clientId])->first();

        if ($client) {
            return DB::table('count_project')->where([
                'client_type' => $clientType,
                'client_id' => $clientId
            ])->increment('total_invited', 1, ['remaining_invited']);
        }
        return DB::table('count_project')->create([
            'client_type' => $clientType,
            'client_id' => $clientId,
            'total_invitation' => 1,
            'remaining_invited' => 1
        ]);
    }

    public function generateCode()
    {
        return rand(100000000, 999999999);
    }

    public function invitation($client, $invitation)
    {
        return $client->invitations()->create([
            'inviter_id' => $invitation->id,
            'inviter_type' => get_class($invitation)
        ]);


    }

    public function increaseInvitation($inviter)
    {
        $client = CountProject::where('client_id', $inviter->id)->where('client_type', get_class($inviter))->first();
        //dd($client);
        if ($client) {

            $project = CountProject::where('client_id', $inviter->id)->where('client_type', get_class($inviter))->update([
                'total_invited' => \DB::raw('total_invited + 1'),
                'remaining_invited' => \DB::raw('remaining_invited + 1'),
            ])->first();

            dd('khob');
            dd($project->fresh());
            CodeService::increaseProjectByUserInvited($project->id);
            return $project;
        }

        return CountProject::create([
            'client_id' => $inviter->id,
            'client_type' => get_class($inviter),
            'total_invited' => 1,
            'remaining_invited' => 1
        ]);
    }

    private static function increaseProjectByUserInvited($id)
    {
        $information = CountProject::query()->select('remaining_project', 'remaining_invited')
            ->where('id', $id)->first();

        $siteInformation = SiteInformation::select('key', 'value')->where('type', 'referral_number')->first();

        $remainingProject = $information['remaining_project'];
        $remainingInvited = $information['remaining_invited'];



        $userNumber = $siteInformation['value'];    //project number
        $projectNumber = $siteInformation['key'];   //user number

        $num = ($remainingInvited / $userNumber) * $projectNumber;
        $remain = $remainingInvited % $userNumber;

        $info = CountProject::query()->where('id', $id)->update([
            'remaining_project' => $num,
            'remaining_invited' => $remain,
        ]);
        dd('asdf');


//        $totalProjectCanAdd = $div * $projectNumber;
//        $div = intdiv($remainingInvited, $userNumber);
    }


}
