<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateTransactionsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('transactions', function (Blueprint $table) {
            $table->id();
            $table->foreignId('billing_plan_id')->nullable()->constrained()->nullOnDelete();
            $table->unsignedBigInteger('client_id');
            $table->text('client_type');
            $table->unsignedBigInteger('amount');
            $table->string('transaction_id');
            $table->unsignedInteger('ref_id')->default(0);
            $table->string('gateway');
            $table->unsignedTinyInteger('status')->default(0);
            $table->timestamps();
            $table->softDeletes();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('transactions');
    }
}
